user/dev discussion of public-inbox itself
 help / color / mirror / code / Atom feed
From: Eric Wong <e@80x24.org>
To: meta@public-inbox.org
Subject: [PATCH 4/4] import_slrnspool: fork a process for each message
Date: Mon, 12 Jan 2015 02:30:57 +0000	[thread overview]
Message-ID: <1421029857-1702-5-git-send-email-e@80x24.org> (raw)
In-Reply-To: <1421029857-1702-1-git-send-email-e@80x24.org>

This prevents process growth when importing large messages.
Memory growth could be due to the sliding sbrk window in glibc malloc
or a circular reference in the Email::* Perl code somewhere.
---
 scripts/import_slrnspool | 46 ++++++++++++++++++++++++++++++----------------
 1 file changed, 30 insertions(+), 16 deletions(-)

diff --git a/scripts/import_slrnspool b/scripts/import_slrnspool
index e55c96c..dd612b1 100755
--- a/scripts/import_slrnspool
+++ b/scripts/import_slrnspool
@@ -66,27 +66,41 @@ for (; $exit == 0 && $n < $max; $n++) {
 	print STDERR $fn, "\n";
 	open(my $fh, '<', $fn) or next;
 	$max = $n + $max_gap;
-	my $f = Email::Filter->new(data => eval { local $/; <$fh> });
-	my $s = $f->simple;
 
-	# gmane rewrites Received headers, which increases spamminess
-	# Some older archives set Original-To
-	foreach my $x (qw(Received To)) {
-		my @h = $s->header("Original-$x");
-		if (@h) {
-			$s->header_set($x, @h);
-			$s->header_set("Original-$x");
+	# prevent process growth by forking a new process for each message
+	my $pid = fork;
+	die "failed to fork: $!\n" unless defined $pid;
+
+	if ($pid == 0) {
+		my $f = Email::Filter->new(data => eval { local $/; <$fh> });
+		close $fh;
+		$fh = undef;
+		my $s = $f->simple;
+
+		# gmane rewrites Received headers, which increases spamminess
+		# Some older archives set Original-To
+		foreach my $x (qw(Received To)) {
+			my @h = $s->header("Original-$x");
+			if (@h) {
+				$s->header_set($x, @h);
+				$s->header_set("Original-$x");
+			}
 		}
-	}
 
-	# triggers for the SA HEADER_SPAM rule
-	foreach my $drop (qw(Approved)) { $s->header_set($drop) }
+		# triggers for the SA HEADER_SPAM rule
+		foreach my $drop (qw(Approved)) { $s->header_set($drop) }
 
-	# appears to be an old gmane bug:
-	$s->header_set('connect()');
+		# appears to be an old gmane bug:
+		$s->header_set('connect()');
 
-	$f->exit(0);
-	$f->pipe(@mda);
+		$f->exit(0);
+		$f->pipe(@mda);
+		exit 0;
+	} else {
+		close $fh;
+		waitpid($pid, 0);
+		die "error: $?\n" if $?;
+	}
 	$ok = $n + 1;
 	set_min($cfg, $ok);
 }
-- 
EW


      parent reply	other threads:[~2015-01-12  2:31 UTC|newest]

Thread overview: 5+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2015-01-12  2:30 [PATCH 0/4] misc import_slrnspool improvements Eric Wong
2015-01-12  2:30 ` [PATCH 1/4] import_slrnspool: make filtering optional Eric Wong
2015-01-12  2:30 ` [PATCH 2/4] import_slrnspool: graceful exit for interruptibility Eric Wong
2015-01-12  2:30 ` [PATCH 3/4] import_slrnspool: load private config key Eric Wong
2015-01-12  2:30 ` Eric Wong [this message]

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://public-inbox.org/README

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1421029857-1702-5-git-send-email-e@80x24.org \
    --to=e@80x24.org \
    --cc=meta@public-inbox.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/public-inbox.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).